stages:
  - test
  - doc
  - publish

variables:
  CARGO_HOME: $CI_PROJECT_DIR/cargo

default:
  image: rust:1.57

.publish:
  stage: publish
#  cache:
#    paths:
#      - cargo/
  allow_failure: false

doc:
  stage: doc
  only:
    - develop
    - /^release/.*$/
    - master
  script:
    - cargo doc --no-deps
    - mv target/doc public
    - echo '<meta http-equiv="refresh" content="0; url={{ LIBRARY NAME }}">' > public/index.html
  artifacts:
    paths:
      - public
#  cache:
#    paths:
#      - target/
#      - cargo/
  allow_failure: false

test:
  stage: test
  rules:
    - if: '$CI_COMMIT_BRANCH == "master"'
      when: never
    - when: on_success
  script:
    - cargo test
    - cargo test --no-default-features
    - cargo test --features deser
  cache:
    paths:
      - cargo/
  allow_failure: false

publish-master:
  extends: .publish
  only:
    - master
  script:
    - cargo test
    - cargo clean
    - cargo login $CARGO_TOKEN
    - cargo publish --dry-run
  allow_failure: true

publish-tags:
  extends: .publish
  only:
    - tags
  script:
    - cargo test
    - cargo clean
    - cargo login $CARGO_TOKEN
    - cargo publish
